cscript "check of beta option" adofiles sheafcoef
use bench\nlsw88, clear
recode occupation (11/12=4) ///
				  (9/10=13)
gen ln_w = ln(wage)

// check beta option in linear regression
sum ln_w if !missing(ln_w, occupation, married, never_married)
gen double z_y = (ln_w -r(mean))/r(sd)

tab occupation, gen(occ)
drop occ1

foreach var of varlist occ? married never_married {
	qui sum `var' if !missing(ln_w, occupation, married, never_married), 
	gen double z_`var' = (`var'-r(mean))/r(sd)
}

reg z_y z_occ? z_married z_never_married
sheafcoef, latent( occupation:z_occ* ; family:z_married z_never_married) post 

// constant is zero
assert reldif([main]_b[_cons],0) < 1e-8
// remove constant
matrix b = e(b)
matrix c = b[1, "main:occupation".."main:family"]
matrix d = b[1,"on_occupation:z_occ2".."on_family:z_never_married"]
matrix b = c, d

matrix v = e(V)
matrix c = v["main:occupation".."main:family", "main:occupation".."main:family"]
matrix d = v["main:occupation".."main:family","on_occupation:z_occ2".."on_family:z_never_married"]
matrix e= v["on_occupation:z_occ2".."on_family:z_never_married","on_occupation:z_occ2".."on_family:z_never_married"]
matrix v = c, d \ d', e

xi: reg ln_w i.occupation married never_married
sheafcoef, latent( occupation:_I* ; family:married never_married) post beta
matrix bb = e(b)
matrix vv = e(V)
assert mreldif(b,bb) < 1e-8
assert mreldif(v,vv) < 1e-8
matrix drop b c d v e bb vv

assert `"`e(cmd)'"'        == `"sheafcoef"'
assert `"`e(properties)'"' == `"b V"'
*assert `"`e(depvar)'"'     == `"ln_w"'

assert         e(N) == 2237

tempname T_b 
mat `T_b' = J(1,12,0)
mat `T_b'[1,1] =  .4695516075268147
mat `T_b'[1,2] =  .0572502704890198
mat `T_b'[1,3] = -.0447335519776119
mat `T_b'[1,4] = -.6998910337583163
mat `T_b'[1,5] = -.3481505176431163
mat `T_b'[1,6] = -.2195490332991936
mat `T_b'[1,7] = -.7255387525330733
mat `T_b'[1,8] = -.4790811672068986
mat `T_b'[1,9] = -.9747900530201297
mat `T_b'[1,10] = -.2115620658471554
mat `T_b'[1,11] = -.5578612957854675
mat `T_b'[1,12] =  .6135245367327245
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-8
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"main:occupation_b main:family_b on_occupation:_Ioccupatio_2_b on_occupation:_Ioccupatio_3_b on_occupation:_Ioccupatio_4_b on_occupation:_Ioccupatio_5_b on_occupation:_Ioccupatio_6_b on_occupation:_Ioccupatio_7_b on_occupation:_Ioccupatio_8_b on_occupation:_Ioccupatio_13_b on_family:married_b on_family:never_married_b"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(12,12,0)
mat `T_V'[1,1] =  .0003508196238406
mat `T_V'[1,2] =  .0000146845735044
mat `T_V'[1,3] = -1.57228203738e-06
mat `T_V'[1,4] =  3.03711373098e-06
mat `T_V'[1,5] =  5.22366727343e-07
mat `T_V'[1,6] =  1.38304780895e-08
mat `T_V'[1,7] = -1.11903840566e-06
mat `T_V'[1,8] = -9.10821029501e-07
mat `T_V'[1,9] =  6.20338732055e-07
mat `T_V'[1,10] =  3.58676428761e-06
mat `T_V'[1,11] = -.0002273397932668
mat `T_V'[1,12] = -.0002194148310138
mat `T_V'[2,1] =  .0000146845735044
mat `T_V'[2,2] =  .0003535465227451
mat `T_V'[2,3] =  7.14551022431e-06
mat `T_V'[2,4] =  .0000728737045901
mat `T_V'[2,5] =  .0000260800593804
mat `T_V'[2,6] =  .0000163540730299
mat `T_V'[2,7] =  6.76466068030e-06
mat `T_V'[2,8] =  7.00283724185e-06
mat `T_V'[2,9] =  5.67165795042e-07
mat `T_V'[2,10] =   .000049310812195
mat `T_V'[2,11] = -.0000351511239045
mat `T_V'[2,12] = -.0000339257716418
mat `T_V'[3,1] = -1.57228203738e-06
mat `T_V'[3,2] =  7.14551022431e-06
mat `T_V'[3,3] =  .0025680715857364
mat `T_V'[3,4] =  .0016425573626348
mat `T_V'[3,5] =  .0007915941420624
mat `T_V'[3,6] =  .0005364923969306
mat `T_V'[3,7] =  .0010837152492874
mat `T_V'[3,8] =  .0003721670467254
mat `T_V'[3,9] =  .0011344583764156
mat `T_V'[3,10] =  .0010035520496266
mat `T_V'[3,11] =  .0008523040438742
mat `T_V'[3,12] =   .000822593110831
mat `T_V'[4,1] =  3.03711373098e-06
mat `T_V'[4,2] =  .0000728737045901
mat `T_V'[4,3] =  .0016425573626348
mat `T_V'[4,4] =  .0027631391387976
mat `T_V'[4,5] =  .0007996608844201
mat `T_V'[4,6] =  .0005566792934629
mat `T_V'[4,7] =  .0008354698756629
mat `T_V'[4,8] =  .0000522101794025
mat `T_V'[4,9] =  .0006679606419939
mat `T_V'[4,10] =  .0012604842006198
mat `T_V'[4,11] = -.0000119464312211
mat `T_V'[4,12] = -.0000115299840382
mat `T_V'[5,1] =  5.22366727343e-07
mat `T_V'[5,2] =  .0000260800593804
mat `T_V'[5,3] =  .0007915941420624
mat `T_V'[5,4] =  .0007996608844201
mat `T_V'[5,5] =  .0018796070513135
mat `T_V'[5,6] =  .0002642840722329
mat `T_V'[5,7] =  .0003904251872911
mat `T_V'[5,8] =   .000017700707029
mat `T_V'[5,9] =  .0003032051432135
mat `T_V'[5,10] =  .0005997604195929
mat `T_V'[5,11] =  .0002533791537301
mat `T_V'[5,12] =   .000244546471162
mat `T_V'[6,1] =  1.38304780895e-08
mat `T_V'[6,2] =  .0000163540730299
mat `T_V'[6,3] =  .0005364923969306
mat `T_V'[6,4] =  .0005566792934629
mat `T_V'[6,5] =  .0002642840722329
mat `T_V'[6,6] =  .0017326875273283
mat `T_V'[6,7] =  .0002821191947745
mat `T_V'[6,8] =    .00002436619336
mat `T_V'[6,9] =  .0002282202851322
mat `T_V'[6,10] =  .0004089681061849
mat `T_V'[6,11] =  .0003020688266238
mat `T_V'[6,12] =  .0002915388441055
mat `T_V'[7,1] = -1.11903840566e-06
mat `T_V'[7,2] =  6.76466068030e-06
mat `T_V'[7,3] =  .0010837152492874
mat `T_V'[7,4] =  .0008354698756629
mat `T_V'[7,5] =  .0003904251872911
mat `T_V'[7,6] =  .0002821191947745
mat `T_V'[7,7] =  .0016763976312865
mat `T_V'[7,8] = -.0001584877977288
mat `T_V'[7,9] =  .0000458429861724
mat `T_V'[7,10] =  .0007454906117275
mat `T_V'[7,11] =  .0006382693342699
mat `T_V'[7,12] =  .0006160195542878
mat `T_V'[8,1] = -9.10821029501e-07
mat `T_V'[8,2] =  7.00283724185e-06
mat `T_V'[8,3] =  .0003721670467254
mat `T_V'[8,4] =  .0000522101794025
mat `T_V'[8,5] =   .000017700707029
mat `T_V'[8,6] =    .00002436619336
mat `T_V'[8,7] = -.0001584877977288
mat `T_V'[8,8] =  .0013436590858468
mat `T_V'[8,9] = -.0003266427819912
mat `T_V'[8,10] =  .0001891275855781
mat `T_V'[8,11] =  .0005477334020756
mat `T_V'[8,12] =  .0005286396636949
mat `T_V'[9,1] =  6.20338732055e-07
mat `T_V'[9,2] =  5.67165795042e-07
mat `T_V'[9,3] =  .0011344583764156
mat `T_V'[9,4] =  .0006679606419939
mat `T_V'[9,5] =  .0003032051432135
mat `T_V'[9,6] =  .0002282202851322
mat `T_V'[9,7] =  .0000458429861724
mat `T_V'[9,8] = -.0003266427819912
mat `T_V'[9,9] =  .0011249845654738
mat `T_V'[9,10] =  .0007340321768821
mat `T_V'[9,11] = -.0002724180003108
mat `T_V'[9,12] = -.0002629216321718
mat `T_V'[10,1] =  3.58676428761e-06
mat `T_V'[10,2] =   .000049310812195
mat `T_V'[10,3] =  .0010035520496266
mat `T_V'[10,4] =  .0012604842006198
mat `T_V'[10,5] =  .0005997604195929
mat `T_V'[10,6] =  .0004089681061849
mat `T_V'[10,7] =  .0007454906117275
mat `T_V'[10,8] =  .0001891275855781
mat `T_V'[10,9] =  .0007340321768821
mat `T_V'[10,10] =  .0022860581824561
mat `T_V'[10,11] = -.0007071122933543
mat `T_V'[10,12] = -.0006824626789908
mat `T_V'[11,1] = -.0002273397932668
mat `T_V'[11,2] = -.0000351511239045
mat `T_V'[11,3] =  .0008523040438742
mat `T_V'[11,4] = -.0000119464312211
mat `T_V'[11,5] =  .0002533791537301
mat `T_V'[11,6] =  .0003020688266238
mat `T_V'[11,7] =  .0006382693342699
mat `T_V'[11,8] =  .0005477334020756
mat `T_V'[11,9] = -.0002724180003108
mat `T_V'[11,10] = -.0007071122933543
mat `T_V'[11,11] =  .1030914528533797
mat `T_V'[11,12] =  .0994977314870792
mat `T_V'[12,1] = -.0002194148310138
mat `T_V'[12,2] = -.0000339257716418
mat `T_V'[12,3] =   .000822593110831
mat `T_V'[12,4] = -.0000115299840382
mat `T_V'[12,5] =   .000244546471162
mat `T_V'[12,6] =  .0002915388441055
mat `T_V'[12,7] =  .0006160195542878
mat `T_V'[12,8] =  .0005286396636949
mat `T_V'[12,9] = -.0002629216321718
mat `T_V'[12,10] = -.0006824626789908
mat `T_V'[12,11] =  .0994977314870792
mat `T_V'[12,12] =  .0960292856203583
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-8
_assert_streq `"`: rowfullnames `C_V''"' `"main:occupation_b main:family_b on_occupation:_Ioccupatio_2_b on_occupation:_Ioccupatio_3_b on_occupation:_Ioccupatio_4_b on_occupation:_Ioccupatio_5_b on_occupation:_Ioccupatio_6_b on_occupation:_Ioccupatio_7_b on_occupation:_Ioccupatio_8_b on_occupation:_Ioccupatio_13_b on_family:married_b on_family:never_married_b"'
_assert_streq `"`: colfullnames `C_V''"' `"main:occupation_b main:family_b on_occupation:_Ioccupatio_2_b on_occupation:_Ioccupatio_3_b on_occupation:_Ioccupatio_4_b on_occupation:_Ioccupatio_5_b on_occupation:_Ioccupatio_6_b on_occupation:_Ioccupatio_7_b on_occupation:_Ioccupatio_8_b on_occupation:_Ioccupatio_13_b on_family:married_b on_family:never_married_b"'
mat drop `C_V' `T_V'



// check if beta option corresponds to -listcoef- from -spost-
// after logit
xi: logit union i.occupation married never_married south
sheafcoef, latent( occ:_I* ; marst:married never_married) post
predict double occ, eq(on_occ)
predict double marst, eq(on_marst)
logit union occ marst south
listcoef, std matrix
matrix b = r(b_std)
xi: logit union i.occupation married never_married south
sheafcoef, latent( occ:_I* ; marst:married never_married) post beta
savedresults save logit e()

matrix bb = e(b)
matrix bb = bb[1,"main:"]
assert mreldif(b,bb) < 1e-6
matrix drop b bb
drop occ marst

assert `"`e(cmd)'"'        == `"sheafcoef"'
assert `"`e(properties)'"' == `"b V"'
*assert `"`e(depvar)'"'     == `"union"'

assert         e(N) == 1869

tempname T_b 
mat `T_b' = J(1,13,0)
mat `T_b'[1,1] =  .3604855343894395
mat `T_b'[1,2] =  .0929491511721043
mat `T_b'[1,3] = -.2243930305337378
mat `T_b'[1,4] = -.5723451839046615
mat `T_b'[1,5] =  .0041193308210491
mat `T_b'[1,6] = -.2489817074871633
mat `T_b'[1,7] = -.0390855808909646
mat `T_b'[1,8] =   .380155790027161
mat `T_b'[1,9] = -.2312665528839034
mat `T_b'[1,10] = -.1665053299429566
mat `T_b'[1,11] =   .532826675571327
mat `T_b'[1,12] = -.9079963340120183
mat `T_b'[1,13] =  .1690339735143586
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"main:occ_b main:marst_b main:south_b on_occ:_Ioccupatio_2_b on_occ:_Ioccupatio_3_b on_occ:_Ioccupatio_4_b on_occ:_Ioccupatio_5_b on_occ:_Ioccupatio_6_b on_occ:_Ioccupatio_7_b on_occ:_Ioccupatio_8_b on_occ:_Ioccupatio_13_b on_marst:married_b on_marst:never_married_b"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(13,13,0)
mat `T_V'[1,1] =  .0011936925601455
mat `T_V'[1,2] =  .0000863221374928
mat `T_V'[1,3] = -.0001403261226814
mat `T_V'[1,4] = -.0008769606157151
mat `T_V'[1,5] =  7.04364106710e-06
mat `T_V'[1,6] = -.0000464143654323
mat `T_V'[1,7] =  .0000399093939388
mat `T_V'[1,8] = -.0005998524920522
mat `T_V'[1,9] = -.0010354999070709
mat `T_V'[1,10] =  .0001154305586698
mat `T_V'[1,11] = -.0008594140581863
mat `T_V'[1,12] = -.0002903938522795
mat `T_V'[1,13] = -.0004756424305382
mat `T_V'[2,1] =  .0000863221374928
mat `T_V'[2,2] =  .0007961902628634
mat `T_V'[2,3] = -.0000354339479203
mat `T_V'[2,4] =  .0000133006455738
mat `T_V'[2,5] =  .0001389006210769
mat `T_V'[2,6] =  .0000207704145991
mat `T_V'[2,7] =  7.94443726479e-06
mat `T_V'[2,8] = -.0001416189275588
mat `T_V'[2,9] =  .0000113843701478
mat `T_V'[2,10] = -.0000702983121084
mat `T_V'[2,11] =   .000103177259008
mat `T_V'[2,12] =  -.000275147603586
mat `T_V'[2,13] = -.0004506702669465
mat `T_V'[3,1] = -.0001403261226814
mat `T_V'[3,2] = -.0000354339479203
mat `T_V'[3,3] =  .0009266688979297
mat `T_V'[3,4] = -.0001107017916354
mat `T_V'[3,5] = -2.16075804271e-06
mat `T_V'[3,6] =  -.000019970075386
mat `T_V'[3,7] = -.0000549106908898
mat `T_V'[3,8] = -.0001980406929416
mat `T_V'[3,9] = -.0001785146678207
mat `T_V'[3,10] = -.0001784387751642
mat `T_V'[3,11] = -.0001012135852266
mat `T_V'[3,12] =  .0003269538441273
mat `T_V'[3,13] =  .0005355248393649
mat `T_V'[4,1] = -.0008769606157151
mat `T_V'[4,2] =  .0000133006455738
mat `T_V'[4,3] = -.0001107017916354
mat `T_V'[4,4] =  .0103014841604495
mat `T_V'[4,5] =  .0061036858739229
mat `T_V'[4,6] =  .0007887181483509
mat `T_V'[4,7] =  .0018618252291401
mat `T_V'[4,8] =   .006063658580309
mat `T_V'[4,9] = -.0020990778864495
mat `T_V'[4,10] =     .0029191097337
mat `T_V'[4,11] =  .0064990451150451
mat `T_V'[4,12] =   .001035377751899
mat `T_V'[4,13] =  .0016958678242421
mat `T_V'[5,1] =  7.04364106710e-06
mat `T_V'[5,2] =  .0001389006210769
mat `T_V'[5,3] = -2.16075804271e-06
mat `T_V'[5,4] =  .0061036858739229
mat `T_V'[5,5] =  .0127864003395796
mat `T_V'[5,6] =  .0039809413494084
mat `T_V'[5,7] =   .003027342678829
mat `T_V'[5,8] =  .0059095847274362
mat `T_V'[5,9] =  .0019400183782221
mat `T_V'[5,10] =  .0058289733115605
mat `T_V'[5,11] =  .0055838420723033
mat `T_V'[5,12] =  .0006141453513448
mat `T_V'[5,13] =  .0010059220790125
mat `T_V'[6,1] = -.0000464143654323
mat `T_V'[6,2] =  .0000207704145991
mat `T_V'[6,3] =  -.000019970075386
mat `T_V'[6,4] =  .0007887181483509
mat `T_V'[6,5] =  .0039809413494084
mat `T_V'[6,6] =  .0103395182605766
mat `T_V'[6,7] =  .0013029091407202
mat `T_V'[6,8] =  .0031706520067842
mat `T_V'[6,9] = -.0004118986324418
mat `T_V'[6,10] =  .0022974730370025
mat `T_V'[6,11] =   .003165543189151
mat `T_V'[6,12] =    .00066151655998
mat `T_V'[6,13] =  .0010835124158462
mat `T_V'[7,1] =  .0000399093939388
mat `T_V'[7,2] =  7.94443726479e-06
mat `T_V'[7,3] = -.0000549106908898
mat `T_V'[7,4] =  .0018618252291401
mat `T_V'[7,5] =   .003027342678829
mat `T_V'[7,6] =  .0013029091407202
mat `T_V'[7,7] =  .0075398585631257
mat `T_V'[7,8] =  .0020946595264769
mat `T_V'[7,9] =  .0004949081278491
mat `T_V'[7,10] =  .0019761238567679
mat `T_V'[7,11] =   .001961810901626
mat `T_V'[7,12] =   .000555067352341
mat `T_V'[7,13] =  .0009091569346511
mat `T_V'[8,1] = -.0005998524920522
mat `T_V'[8,2] = -.0001416189275588
mat `T_V'[8,3] = -.0001980406929416
mat `T_V'[8,4] =   .006063658580309
mat `T_V'[8,5] =  .0059095847274362
mat `T_V'[8,6] =  .0031706520067842
mat `T_V'[8,7] =  .0020946595264769
mat `T_V'[8,8] =  .0081389369048918
mat `T_V'[8,9] =  .0028473056779855
mat `T_V'[8,10] =  .0041563577766086
mat `T_V'[8,11] =  .0037765353316908
mat `T_V'[8,12] =  .0013688574282687
mat `T_V'[8,13] =   .002242081466709
mat `T_V'[9,1] = -.0010354999070709
mat `T_V'[9,2] =  .0000113843701478
mat `T_V'[9,3] = -.0001785146678207
mat `T_V'[9,4] = -.0020990778864495
mat `T_V'[9,5] =  .0019400183782221
mat `T_V'[9,6] = -.0004118986324418
mat `T_V'[9,7] =  .0004949081278491
mat `T_V'[9,8] =  .0028473056779855
mat `T_V'[9,9] =  .0203804051193575
mat `T_V'[9,10] =  .0005432152992628
mat `T_V'[9,11] =  .0033482041508144
mat `T_V'[9,12] = -.0002288181062947
mat `T_V'[9,13] = -.0003747861718657
mat `T_V'[10,1] =  .0001154305586698
mat `T_V'[10,2] = -.0000702983121084
mat `T_V'[10,3] = -.0001784387751642
mat `T_V'[10,4] =     .0029191097337
mat `T_V'[10,5] =  .0058289733115605
mat `T_V'[10,6] =  .0022974730370025
mat `T_V'[10,7] =  .0019761238567679
mat `T_V'[10,8] =  .0041563577766086
mat `T_V'[10,9] =  .0005432152992628
mat `T_V'[10,10] =  .0105310349768858
mat `T_V'[10,11] =  .0039737421409878
mat `T_V'[10,12] = -.0009769517380378
mat `T_V'[10,13] = -.0016001705805798
mat `T_V'[11,1] = -.0008594140581863
mat `T_V'[11,2] =   .000103177259008
mat `T_V'[11,3] = -.0001012135852266
mat `T_V'[11,4] =  .0064990451150451
mat `T_V'[11,5] =  .0055838420723033
mat `T_V'[11,6] =   .003165543189151
mat `T_V'[11,7] =   .001961810901626
mat `T_V'[11,8] =  .0037765353316908
mat `T_V'[11,9] =  .0033482041508144
mat `T_V'[11,10] =  .0039737421409878
mat `T_V'[11,11] =  .0075784560505528
mat `T_V'[11,12] = -.0000101520069669
mat `T_V'[11,13] = -.0000166281938501
mat `T_V'[12,1] = -.0002903938522795
mat `T_V'[12,2] =  -.000275147603586
mat `T_V'[12,3] =  .0003269538441273
mat `T_V'[12,4] =   .001035377751899
mat `T_V'[12,5] =  .0006141453513448
mat `T_V'[12,6] =    .00066151655998
mat `T_V'[12,7] =   .000555067352341
mat `T_V'[12,8] =  .0013688574282687
mat `T_V'[12,9] = -.0002288181062947
mat `T_V'[12,10] = -.0009769517380378
mat `T_V'[12,11] = -.0000101520069669
mat `T_V'[12,12] =  .0411228530988067
mat `T_V'[12,13] =  .0673560188862395
mat `T_V'[13,1] = -.0004756424305382
mat `T_V'[13,2] = -.0004506702669465
mat `T_V'[13,3] =  .0005355248393649
mat `T_V'[13,4] =  .0016958678242421
mat `T_V'[13,5] =  .0010059220790125
mat `T_V'[13,6] =  .0010835124158462
mat `T_V'[13,7] =  .0009091569346511
mat `T_V'[13,8] =   .002242081466709
mat `T_V'[13,9] = -.0003747861718657
mat `T_V'[13,10] = -.0016001705805798
mat `T_V'[13,11] = -.0000166281938501
mat `T_V'[13,12] =  .0673560188862395
mat `T_V'[13,13] =  .1103238938529561
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-4
_assert_streq `"`: rowfullnames `C_V''"' `"main:occ_b main:marst_b main:south_b on_occ:_Ioccupatio_2_b on_occ:_Ioccupatio_3_b on_occ:_Ioccupatio_4_b on_occ:_Ioccupatio_5_b on_occ:_Ioccupatio_6_b on_occ:_Ioccupatio_7_b on_occ:_Ioccupatio_8_b on_occ:_Ioccupatio_13_b on_marst:married_b on_marst:never_married_b"'
_assert_streq `"`: colfullnames `C_V''"' `"main:occ_b main:marst_b main:south_b on_occ:_Ioccupatio_2_b on_occ:_Ioccupatio_3_b on_occ:_Ioccupatio_4_b on_occ:_Ioccupatio_5_b on_occ:_Ioccupatio_6_b on_occ:_Ioccupatio_7_b on_occ:_Ioccupatio_8_b on_occ:_Ioccupatio_13_b on_marst:married_b on_marst:never_married_b"'
mat drop `C_V' `T_V'

// check that -logistic- leads to the same results as -logit-
xi: logistic union i.occupation married never_married south
sheafcoef, latent( occ:_I* ; marst:married never_married) post beta
savedresults compare logit e()


// check if beta option corresponds to -listcoef- from -spost-
// after probit
xi: probit union i.occupation married never_married south
sheafcoef, latent( occ:_I* ; marst:married never_married) post
predict double occ, eq(on_occ)
predict double marst, eq(on_marst)
probit union occ marst south
listcoef, std matrix
matrix b = r(b_std)
xi: probit union i.occupation married never_married south
sheafcoef, latent( occ:_I* ; marst:married never_married) post beta
matrix bb = e(b)
matrix bb = bb[1,"main:"]
assert mreldif(b,bb) < 1e-6
matrix drop b bb
drop occ marst

assert `"`e(cmd)'"'        == `"sheafcoef"'
assert `"`e(properties)'"' == `"b V"'
*assert `"`e(depvar)'"'     == `"union"'

assert         e(N) == 1869

tempname T_b 
mat `T_b' = J(1,13,0)
mat `T_b'[1,1] =  .3717642862145834
mat `T_b'[1,2] =  .0984910437190739
mat `T_b'[1,3] = -.2289130733159512
mat `T_b'[1,4] = -.5506970618446325
mat `T_b'[1,5] =  .0043636965531934
mat `T_b'[1,6] = -.2397990218283805
mat `T_b'[1,7] =   -.04897319429712
mat `T_b'[1,8] =  .3883855499447831
mat `T_b'[1,9] = -.2170890356991403
mat `T_b'[1,10] = -.1703894034127626
mat `T_b'[1,11] =  .5560516153969802
mat `T_b'[1,12] = -.9157099014068425
mat `T_b'[1,13] =  .1562939967032075
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"main:occ_b main:marst_b main:south_b on_occ:_Ioccupatio_2_b on_occ:_Ioccupatio_3_b on_occ:_Ioccupatio_4_b on_occ:_Ioccupatio_5_b on_occ:_Ioccupatio_6_b on_occ:_Ioccupatio_7_b on_occ:_Ioccupatio_8_b on_occ:_Ioccupatio_13_b on_marst:married_b on_marst:never_married_b"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(13,13,0)
mat `T_V'[1,1] =  .0010883571130069
mat `T_V'[1,2] =  .0000802095083644
mat `T_V'[1,3] = -.0001261780568663
mat `T_V'[1,4] =   -.00055787381946
mat `T_V'[1,5] =  8.04422308869e-06
mat `T_V'[1,6] = -.0000472648476363
mat `T_V'[1,7] =   .000015957591648
mat `T_V'[1,8] = -.0003562873034233
mat `T_V'[1,9] = -.0005762324181423
mat `T_V'[1,10] =  .0000565005273277
mat `T_V'[1,11] = -.0004995632096537
mat `T_V'[1,12] = -.0003189338255679
mat `T_V'[1,13] = -.0005312006366706
mat `T_V'[2,1] =  .0000802095083644
mat `T_V'[2,2] =  .0008848928419333
mat `T_V'[2,3] = -.0000375197638051
mat `T_V'[2,4] = -1.39279213751e-06
mat `T_V'[2,5] =  .0001368274849539
mat `T_V'[2,6] = -.0000262268807135
mat `T_V'[2,7] = -1.62605148947e-06
mat `T_V'[2,8] = -.0001692888855615
mat `T_V'[2,9] =  .0000341442030214
mat `T_V'[2,10] = -.0000646404860638
mat `T_V'[2,11] =  .0000971271828776
mat `T_V'[2,12] = -.0001855600678603
mat `T_V'[2,13] = -.0003090598057842
mat `T_V'[3,1] = -.0001261780568663
mat `T_V'[3,2] = -.0000375197638051
mat `T_V'[3,3] =  .0009628211793712
mat `T_V'[3,4] = -.0000491123919946
mat `T_V'[3,5] = -.0000153785670179
mat `T_V'[3,6] = -.0000430123770233
mat `T_V'[3,7] = -.0000245605849635
mat `T_V'[3,8] = -.0001559122876658
mat `T_V'[3,9] = -.0001195631821509
mat `T_V'[3,10] = -.0001670746529343
mat `T_V'[3,11] = -.0000465375981422
mat `T_V'[3,12] =  .0003385483227509
mat `T_V'[3,13] =  .0005638695872688
mat `T_V'[4,1] =   -.00055787381946
mat `T_V'[4,2] = -1.39279213751e-06
mat `T_V'[4,3] = -.0000491123919946
mat `T_V'[4,4] =  .0096079424847043
mat `T_V'[4,5] =  .0063217150136345
mat `T_V'[4,6] =  .0014124146600835
mat `T_V'[4,7] =  .0019190727783177
mat `T_V'[4,8] =   .005984973453594
mat `T_V'[4,9] =  -.000746918590838
mat `T_V'[4,10] =  .0032498055158245
mat `T_V'[4,11] =  .0064212650182468
mat `T_V'[4,12] =  .0009719266799956
mat `T_V'[4,13] =  .0016187937114901
mat `T_V'[5,1] =  8.04422308869e-06
mat `T_V'[5,2] =  .0001368274849539
mat `T_V'[5,3] = -.0000153785670179
mat `T_V'[5,4] =  .0063217150136345
mat `T_V'[5,5] =  .0132407659485148
mat `T_V'[5,6] =  .0041207923645983
mat `T_V'[5,7] =  .0031376991926353
mat `T_V'[5,8] =  .0061237632225235
mat `T_V'[5,9] =   .002013422850603
mat `T_V'[5,10] =  .0060574701733549
mat `T_V'[5,11] =  .0057848823182449
mat `T_V'[5,12] =  .0004638066550124
mat `T_V'[5,13] =  .0007724937610362
mat `T_V'[6,1] = -.0000472648476363
mat `T_V'[6,2] = -.0000262268807135
mat `T_V'[6,3] = -.0000430123770233
mat `T_V'[6,4] =  .0014124146600835
mat `T_V'[6,5] =  .0041207923645983
mat `T_V'[6,6] =  .0092317903505536
mat `T_V'[6,7] =  .0013370250382679
mat `T_V'[6,8] =  .0033421984708397
mat `T_V'[6,9] =   .000090978082071
mat `T_V'[6,10] =  .0024184088890774
mat `T_V'[6,11] =  .0033695585364048
mat `T_V'[6,12] =   .000695190777962
mat `T_V'[6,13] =  .0011578758797484
mat `T_V'[7,1] =   .000015957591648
mat `T_V'[7,2] = -1.62605148947e-06
mat `T_V'[7,3] = -.0000245605849635
mat `T_V'[7,4] =  .0019190727783177
mat `T_V'[7,5] =  .0031376991926353
mat `T_V'[7,6] =  .0013370250382679
mat `T_V'[7,7] =  .0077335293308022
mat `T_V'[7,8] =  .0022147465467917
mat `T_V'[7,9] =  .0005364333172844
mat `T_V'[7,10] =  .0020259485726736
mat `T_V'[7,11] =  .0021040897724025
mat `T_V'[7,12] =  .0005342730425365
mat `T_V'[7,13] =   .000889859141927
mat `T_V'[8,1] = -.0003562873034233
mat `T_V'[8,2] = -.0001692888855615
mat `T_V'[8,3] = -.0001559122876658
mat `T_V'[8,4] =   .005984973453594
mat `T_V'[8,5] =  .0061237632225235
mat `T_V'[8,6] =  .0033421984708397
mat `T_V'[8,7] =  .0022147465467917
mat `T_V'[8,8] =  .0084879383826081
mat `T_V'[8,9] =  .0024188906783369
mat `T_V'[8,10] =  .0044135416603975
mat `T_V'[8,11] =  .0032864438237844
mat `T_V'[8,12] =   .001298781127079
mat `T_V'[8,13] =  .0021631865493465
mat `T_V'[9,1] = -.0005762324181423
mat `T_V'[9,2] =  .0000341442030214
mat `T_V'[9,3] = -.0001195631821509
mat `T_V'[9,4] =  -.000746918590838
mat `T_V'[9,5] =   .002013422850603
mat `T_V'[9,6] =   .000090978082071
mat `T_V'[9,7] =  .0005364333172844
mat `T_V'[9,8] =  .0024188906783369
mat `T_V'[9,9] =  .0143980714457818
mat `T_V'[9,10] =  .0008154411481288
mat `T_V'[9,11] =  .0027948444394006
mat `T_V'[9,12] = -.0001838967183407
mat `T_V'[9,13] = -.0003062894118875
mat `T_V'[10,1] =  .0000565005273277
mat `T_V'[10,2] = -.0000646404860638
mat `T_V'[10,3] = -.0001670746529343
mat `T_V'[10,4] =  .0032498055158245
mat `T_V'[10,5] =  .0060574701733549
mat `T_V'[10,6] =  .0024184088890774
mat `T_V'[10,7] =  .0020259485726736
mat `T_V'[10,8] =  .0044135416603975
mat `T_V'[10,9] =  .0008154411481288
mat `T_V'[10,10] =  .0103329372006117
mat `T_V'[10,11] =  .0042983957747413
mat `T_V'[10,12] =  -.001085285805182
mat `T_V'[10,13] = -.0018075991458595
mat `T_V'[11,1] = -.0004995632096537
mat `T_V'[11,2] =  .0000971271828776
mat `T_V'[11,3] = -.0000465375981422
mat `T_V'[11,4] =  .0064212650182468
mat `T_V'[11,5] =  .0057848823182449
mat `T_V'[11,6] =  .0033695585364048
mat `T_V'[11,7] =  .0021040897724025
mat `T_V'[11,8] =  .0032864438237844
mat `T_V'[11,9] =  .0027948444394006
mat `T_V'[11,10] =  .0042983957747413
mat `T_V'[11,11] =  .0075433572634166
mat `T_V'[11,12] =  -.000050146145738
mat `T_V'[11,13] = -.0000835209764758
mat `T_V'[12,1] = -.0003189338255679
mat `T_V'[12,2] = -.0001855600678603
mat `T_V'[12,3] =  .0003385483227509
mat `T_V'[12,4] =  .0009719266799956
mat `T_V'[12,5] =  .0004638066550124
mat `T_V'[12,6] =   .000695190777962
mat `T_V'[12,7] =  .0005342730425365
mat `T_V'[12,8] =   .001298781127079
mat `T_V'[12,9] = -.0001838967183407
mat `T_V'[12,10] =  -.001085285805182
mat `T_V'[12,11] =  -.000050146145738
mat `T_V'[12,12] =  .0402532568727411
mat `T_V'[12,13] =  .0670438629104037
mat `T_V'[13,1] = -.0005312006366706
mat `T_V'[13,2] = -.0003090598057842
mat `T_V'[13,3] =  .0005638695872688
mat `T_V'[13,4] =  .0016187937114901
mat `T_V'[13,5] =  .0007724937610362
mat `T_V'[13,6] =  .0011578758797484
mat `T_V'[13,7] =   .000889859141927
mat `T_V'[13,8] =  .0021631865493465
mat `T_V'[13,9] = -.0003062894118875
mat `T_V'[13,10] = -.0018075991458595
mat `T_V'[13,11] = -.0000835209764758
mat `T_V'[13,12] =  .0670438629104037
mat `T_V'[13,13] =  .1116649906903029
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-4
_assert_streq `"`: rowfullnames `C_V''"' `"main:occ_b main:marst_b main:south_b on_occ:_Ioccupatio_2_b on_occ:_Ioccupatio_3_b on_occ:_Ioccupatio_4_b on_occ:_Ioccupatio_5_b on_occ:_Ioccupatio_6_b on_occ:_Ioccupatio_7_b on_occ:_Ioccupatio_8_b on_occ:_Ioccupatio_13_b on_marst:married_b on_marst:never_married_b"'
_assert_streq `"`: colfullnames `C_V''"' `"main:occ_b main:marst_b main:south_b on_occ:_Ioccupatio_2_b on_occ:_Ioccupatio_3_b on_occ:_Ioccupatio_4_b on_occ:_Ioccupatio_5_b on_occ:_Ioccupatio_6_b on_occ:_Ioccupatio_7_b on_occ:_Ioccupatio_8_b on_occ:_Ioccupatio_13_b on_marst:married_b on_marst:never_married_b"'
mat drop `C_V' `T_V'

// cannot use the beta option after -cluster()- or -svy-
reg ln_w occ? married never_married, cluster(grade)
rcof "noisily sheafcoef , laten(occ: occ? ; marst: married never_married) beta" == 198

gen w = uniform()
svyset [pw=w]
svy: reg ln_w occ? married never_married
rcof "noisily sheafcoef , laten(occ: occ? ; marst: married never_married) beta" == 198
